// ___SETA43  _____
// 13/03/2025 _____
//LUCES DE NAVIDAD3
//Arduino 1.8.19
// seta43.duckdns.org
// seta43.blogspot.com

#define OUT_A 2
#define OUT_B 3
#define BUTTON_PIN 7

#define PAUSAX 16

byte modo=100;

void setup() 
{
  Serial.begin(9600);
  while (!Serial) {;}
  Serial.println("\nLucesNavi (Seta43)");
  pinMode(OUT_A, OUTPUT);
  pinMode(OUT_B, OUTPUT);
  pinMode(BUTTON_PIN, INPUT_PULLUP);
  printModo();
}

int z;

void loop() 
{
  change();

  switch(modo)
  {
     case 0:
        ciclo1(1000,2000);
     break;
     case 1:
        ciclo1(500,2000);
     break;
     case 2:
        ciclo1(200,2000);
     break;
      case 3:
        ciclo1(100,1000);
     break;   
     
     case 4:
          ciclo1(50,1000);       
          for(z=0;z<=PAUSAX;z++) ciclo2(PAUSAX-z,z,500);
          ciclo1(50,1000);
          for(z=0;z<=PAUSAX;z++) ciclo2(z,PAUSAX-z,500);
          digitalWrite(OUT_A, LOW); 
          digitalWrite(OUT_B, LOW); 
     break;
     case 5:
          for(z=0;z<=100;z++)cicloA(z,100);
          for(z=0;z<=100;z++)cicloB(z,100);
          digitalWrite(OUT_A, LOW); 
          digitalWrite(OUT_B, LOW);  
     break;
     case 6:
          for(z=0;z<16;z++) cicloCa(z,8);  
          for(z=16;z>=0;z--) cicloCa(z,8);
          for(z=0;z<16;z++) cicloCb(z,8);  
          for(z=16;z>=0;z--) cicloCb(z,8);
     break;    
     case 7:
        digitalWrite(OUT_A, LOW); 
        digitalWrite(OUT_B, HIGH); 
     break;
     case 8:
        digitalWrite(OUT_B, LOW); 
        digitalWrite(OUT_A, HIGH);
     break;
     case 9:
        ciclo1(10,1000);
     break;
      case 10:
          digitalWrite(OUT_A, LOW); 
          digitalWrite(OUT_B, LOW); 
     break;
     default:
        modo=0;
        printModo();
     break;
  }
  
}


// ===================================

void change(void)
{
  if (digitalRead(BUTTON_PIN) == 0) 
        {
          printModo();
          delay(400);
          while(digitalRead(BUTTON_PIN) == 0){;}
        }
}


void printModo(void)
{
   modo++; 
  switch(modo)
  {
//     case 0:
//        Serial.print("Dual1 -");
//     break;
     case 1:
        Serial.print("Dual2 -");
     break;
     case 2:
        Serial.print("Dual3 -");      
     break;
     case 3:
        Serial.print("Dual4 -");
     break;
     case 4:
        Serial.print("Flash+1 -");
     break;
     case 5:
        Serial.print("FLASH-Dual -");      
     break;
     case 6:
        Serial.print("Disolver -");
     break;
     case 7:
        Serial.print("Led_A -");
     break;
     case 8:
        Serial.print("Led_B -");      
     break;
     case 9:
        Serial.print("ON    -");
     break;
     case 10:
        Serial.print("OFF   -");      
     break;
     
     default:
        Serial.println("===============");
        modo=0;
        Serial.print("Dual1 -");
     break;
  }
  Serial.print("Modo=");  Serial.println(modo);
}

//---%16 ciclo, tiempo-A
void cicloCa(int t1,int s)
{
 int t2;
      t2=16-t1;     
      while(s>0)
      {
          digitalWrite(OUT_A, HIGH); 
          digitalWrite(OUT_B, LOW);
          delay(t1);
          digitalWrite(OUT_B, HIGH);
          delay(t2);         
          s--;
          if (digitalRead(BUTTON_PIN) == 0) return; 
      }
}

//---%16 ciclo, tiempo-B
void cicloCb(int t1,int s)
{
 int t2;
      t2=16-t1;     
      while(s>0)
      {
          digitalWrite(OUT_A, LOW); 
          digitalWrite(OUT_B, HIGH);
          delay(t1);
          digitalWrite(OUT_B, LOW);
          delay(t2);         
          s--;
          if (digitalRead(BUTTON_PIN) == 0) return; 
      }
}



// tiempo  estado, tiempo Msegundos
void cicloA(int t1,int s)
{

      long tt,tt1;
  
      tt1=t1*10; 
      digitalWrite(OUT_A, HIGH); 
      digitalWrite(OUT_B, LOW);
      for(tt=0;tt<tt1;tt++)
        {
          delayMicroseconds(100);
          if (digitalRead(BUTTON_PIN) == 0) return;  
        }
      digitalWrite(OUT_A, LOW); 
      digitalWrite(OUT_B, LOW);  
      for(tt=0;tt<tt1;tt++)
        {
          delayMicroseconds(100);
          if (digitalRead(BUTTON_PIN) == 0) return;  
        } 
}


// tiempo  estado, tiempo Msegundos
void cicloB(int t1,int s)
{
 long tt,tt1;
  
      tt1=t1*10; 
      digitalWrite(OUT_B, HIGH); 
      digitalWrite(OUT_A, LOW);
      for(tt=0;tt<tt1;tt++)
        {
          delayMicroseconds(100);
          if (digitalRead(BUTTON_PIN) == 0) return;  
        }
      digitalWrite(OUT_B, LOW); 
      digitalWrite(OUT_A, LOW);  
      for(tt=0;tt<tt1;tt++)
        {
          delayMicroseconds(100);
          if (digitalRead(BUTTON_PIN) == 0) return;  
        } 
}


void ciclo1(int x,int s)
{
 long t;
    t=s; 
    t=t/(x*2);
    while(t>0)
      {
        if (digitalRead(BUTTON_PIN) == 0) t=0; 
        ciclox(x);
        t--;  
      }
}


// tiempo de cada estado, tiempo segundo
void ciclo2(int x1,int x2,int s)
{
 long t;
    t=s;
    t=t/(x1+x2);
    while(t>0)
      {
        cicloy(x1,x2);
        t--;  
      }
}



//========================================
void ciclox(int x)  {  cicloy(x,x); }

void cicloy(int t1,int t2)
{
 long tt,tt1,tt2;
  
      tt1=t1*10;  tt2=t2*10;
      digitalWrite(OUT_A, HIGH); 
      digitalWrite(OUT_B, LOW);
      for(tt=0;tt<tt1;tt++)
        {
          delayMicroseconds(100);
          if (digitalRead(BUTTON_PIN) == 0) return;  
        }
      digitalWrite(OUT_A, LOW); 
      digitalWrite(OUT_B, HIGH);  
      for(tt=0;tt<tt2;tt++)
        {
          delayMicroseconds(100);
          if (digitalRead(BUTTON_PIN) == 0) return;  
        } 
}
